import numpy as np
from pysc2.lib import actions, features, units

class HistoryRecord():

    def __init__(self):
        self.history = []

    def addHistoryRecord (self, epochRecord):
        for entry in epochRecord.scenarioRecord:
            self.history.append(entry)

    def clearHistoryRecord (self):
        self.history = []

    def convertToNPArray (self):
        #determine the shape of the NP Array
        #First how many inputs do we have
        x_dim = len(self.history[0][0]) #Should grab the first input tuple and determine the length
        y_dim = 0
        for entry in self.history:
            y_dim += 1 #Should grab how many steps we in the epoch and add to y_dim
        #initialize the np array
        self.modelInputs = np.empty([y_dim, x_dim])
        self.modelOutputs = np.empty([y_dim, 4]) #4 is the number of possible actions. Update this later without magic number
        inputCounter = 0
        for step in self.history:
            stepCounter = 0
            for item in step[0]:
                self.modelInputs[inputCounter][stepCounter] = item
                stepCounter += 1
            self.modelOutputs[inputCounter] = self.returnOutputMatrix(step[1], step[3])
            inputCounter += 1 #Yeah hopefully that works

    def returnOutputMatrix (self, selectedAction, reward):
        _GAME_ACTIONS = ["home",
                              "enemy",
                              "retreat-horizontal",
                              "retreat-vertical"]
        if reward == 0:
             return [0, 0, 0, 0]
        #    return 4
        else:
            returnList = [0, 0, 0, 0]
            #counter = 0
            returnList[selectedAction] = reward
            #for item in range(0, len(_GAME_ACTIONS)-1):
            #    if _GAME_ACTIONS[item == selectedAction:
            #        returnList.append(reward)
            #        #returnList.append(1)
            #        #return counter
            #    else:
            #        returnList.append(0)
            #        #counter += 1
            return np.array(returnList)
