# Class to record every action, result, and reward for one epoch
class ScenarioRecord ():

    def __init__ (self):
        self.scenarioRecord = []

    '''
    This will add a record for each step of the game.
    The action is the id number of the action that was selected.
    The result will be a true or False, whether the action was able to execute
    '''
    def addStep (self, inputs, action, result):
        self.scenarioRecord.append((inputs, action, result, 0)) #Initialize each entry with a 0 reward

    def assignReward (self):
        denom = len(self.scenarioRecord)
        for entryIdx in range(len(self.scenarioRecord)):
            if self.scenarioRecord[entryIdx][2] == True: #This action successfully executed
                self.scenarioRecord[entryIdx] = list(self.scenarioRecord[entryIdx])
                self.scenarioRecord[entryIdx][3] = (self.normalizedReward / denom)# * entryIdx
                self.scenarioRecord[entryIdx] = tuple(self.scenarioRecord[entryIdx])

    def normalizeReward (self, scenarioReward):
        #self.normalizedReward = scenarioReward/3500 #This is the highest reward I've seen in the scenario. This should provide reward values between 0 and 1
        self.normalizedReward = scenarioReward + 0.01 #It's already -1 or 1. 0.01 is to avoid divide by zero if it is a tie.

    def getStep(self, idx):
        return self.scenarioRecord[idx]

    def clearRecord(self):
        self.scenarioRecord.clear()
